Index: waflib/Tools/ar.py
===================================================================
--- waflib/Tools/ar.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/ar.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -9,3 +9,5 @@
 def configure(conf):
 	conf.find_program('ar',var='AR')
-	conf.env.ARFLAGS='rcs'
+	conf.add_os_flags('ARFLAGS')
+	if not conf.env.ARFLAGS:
+		conf.env.ARFLAGS=['rcs']
Index: waflib/Tools/asm.py
===================================================================
--- waflib/Tools/asm.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/asm.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -10,5 +10,5 @@
 class asm(Task.Task):
 	color='BLUE'
-	run_str='${AS} ${ASFLAGS} ${ASMPATH_ST:INCPATHS} ${AS_SRC_F}${SRC} ${AS_TGT_F}${TGT}'
+	run_str='${AS} ${ASFLAGS} ${ASMPATH_ST:INCPATHS} ${DEFINES_ST:DEFINES} ${AS_SRC_F}${SRC} ${AS_TGT_F}${TGT}'
 @extension('.s','.S','.asm','.ASM','.spp','.SPP')
 def asm_hook(self,node):
Index: waflib/Tools/c.py
===================================================================
--- waflib/Tools/c.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/c.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -8,7 +8,9 @@
 @TaskGen.extension('.c')
 def c_hook(self,node):
+	if not self.env.CC and self.env.CXX:
+		return self.create_compiled_task('cxx',node)
 	return self.create_compiled_task('c',node)
 class c(Task.Task):
-	run_str='${CC} ${ARCH_ST:ARCH} ${CFLAGS} ${CPPFLAGS} ${FRAMEWORKPATH_ST:FRAMEWORKPATH} ${CPPPATH_ST:INCPATHS} ${DEFINES_ST:DEFINES} ${CC_SRC_F}${SRC} ${CC_TGT_F}${TGT}'
+	run_str='${CC} ${ARCH_ST:ARCH} ${CFLAGS} ${CPPFLAGS} ${FRAMEWORKPATH_ST:FRAMEWORKPATH} ${CPPPATH_ST:INCPATHS} ${DEFINES_ST:DEFINES} ${CC_SRC_F}${SRC} ${CC_TGT_F}${TGT[0].abspath()}'
 	vars=['CCDEPS']
 	ext_in=['.h']
Index: waflib/Tools/c_aliases.py
===================================================================
--- waflib/Tools/c_aliases.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/c_aliases.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -30,7 +30,7 @@
 	if'java'in exts:
 		return'java'
-	if type in['program','shlib','stlib']:
+	if type in('program','shlib','stlib'):
 		for x in feats:
-			if x in['cxx','d','c']:
+			if x in('cxx','d','c'):
 				feats.append(x+type)
 	return feats
Index: waflib/Tools/c_config.py
===================================================================
--- waflib/Tools/c_config.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/c_config.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -44,13 +44,17 @@
 MACRO_TO_DEST_CPU={'__x86_64__':'x86_64','__amd64__':'x86_64','__i386__':'x86','__ia64__':'ia','__mips__':'mips','__sparc__':'sparc','__alpha__':'alpha','__aarch64__':'aarch64','__thumb__':'thumb','__arm__':'arm','__hppa__':'hppa','__powerpc__':'powerpc','__ppc__':'powerpc','__convex__':'convex','__m68k__':'m68k','__s390x__':'s390x','__s390__':'s390','__sh__':'sh',}
 @conf
-def parse_flags(self,line,uselib_store,env=None,force_static=False):
+def parse_flags(self,line,uselib_store,env=None,force_static=False,posix=None):
 	assert(isinstance(line,str))
 	env=env or self.env
-	app=env.append_value
-	appu=env.append_unique
-	lex=shlex.shlex(line,posix=False)
+	if posix is None:
+		posix=True
+		if'\\'in line:
+			posix=('\\ 'in line)or('\\\\'in line)
+	lex=shlex.shlex(line,posix=posix)
 	lex.whitespace_split=True
 	lex.commenters=''
 	lst=list(lex)
+	app=env.append_value
+	appu=env.append_unique
 	uselib=uselib_store
 	while lst:
@@ -61,5 +65,5 @@
 			if not ot:ot=lst.pop(0)
 			appu('INCLUDES_'+uselib,[ot])
-		elif st=='-include':
+		elif st=='-i':
 			tmp=[x,lst.pop(0)]
 			app('CFLAGS',tmp)
@@ -85,4 +89,10 @@
 		elif x.startswith('-F'):
 			appu('FRAMEWORKPATH_'+uselib,[x[2:]])
+		elif x=='-Wl,-rpath':
+			app('RPATH_'+uselib,lst.pop(0))
+		elif x.startswith('-Wl,-R'):
+			app('RPATH_'+uselib,x[6:])
+		elif x.startswith('-Wl,-rpath,'):
+			app('RPATH_'+uselib,x[11:])
 		elif x.startswith('-Wl'):
 			app('LINKFLAGS_'+uselib,[x])
@@ -92,5 +102,5 @@
 		elif x.startswith('-bundle'):
 			app('LINKFLAGS_'+uselib,[x])
-		elif x.startswith('-undefined'):
+		elif x.startswith('-undefined')or x.startswith('-Xlinker'):
 			arg=lst.pop(0)
 			app('LINKFLAGS_'+uselib,[x,arg])
@@ -102,9 +112,4 @@
 		elif x.endswith('.a')or x.endswith('.so')or x.endswith('.dylib')or x.endswith('.lib'):
 			appu('LINKFLAGS_'+uselib,[x])
-@conf
-def ret_msg(self,f,kw):
-	if isinstance(f,str):
-		return f
-	return f(kw)
 @conf
 def validate_cfg(self,kw):
@@ -133,12 +138,23 @@
 				kw['msg']='Checking for %r %s %s'%(kw['package'],cfg_ver[x],kw[y])
 			return
+	if not'define_name'in kw:
+		pkgname=kw.get('uselib_store',kw['package'].upper())
+		kw['define_name']=self.have_define(pkgname)
+	if not'uselib_store'in kw:
+		self.undefine(kw['define_name'])
 	if not'msg'in kw:
 		kw['msg']='Checking for %r'%(kw['package']or kw['path'])
 @conf
 def exec_cfg(self,kw):
+	path=Utils.to_list(kw['path'])
 	def define_it():
-		self.define(self.have_define(kw.get('uselib_store',kw['package'])),1,0)
+		pkgname=kw.get('uselib_store',kw['package'].upper())
+		if kw.get('global_define'):
+			self.define(self.have_define(kw['package']),1,False)
+		else:
+			self.env.append_unique('DEFINES_%s'%pkgname,"%s=1"%self.have_define(pkgname))
+		self.env[self.have_define(pkgname)]=1
 	if'atleast_pkgconfig_version'in kw:
-		cmd=[kw['path'],'--atleast-pkgconfig-version=%s'%kw['atleast_pkgconfig_version']]
+		cmd=path+['--atleast-pkgconfig-version=%s'%kw['atleast_pkgconfig_version']]
 		self.cmd_and_log(cmd)
 		if not'okmsg'in kw:
@@ -148,5 +164,5 @@
 		y=x.replace('-','_')
 		if y in kw:
-			self.cmd_and_log([kw['path'],'--%s=%s'%(x,kw[y]),kw['package']])
+			self.cmd_and_log(path+['--%s=%s'%(x,kw[y]),kw['package']])
 			if not'okmsg'in kw:
 				kw['okmsg']='yes'
@@ -154,8 +170,8 @@
 			break
 	if'modversion'in kw:
-		version=self.cmd_and_log([kw['path'],'--modversion',kw['modversion']]).strip()
+		version=self.cmd_and_log(path+['--modversion',kw['modversion']]).strip()
 		self.define('%s_VERSION'%Utils.quote_define_name(kw.get('uselib_store',kw['modversion'])),version)
 		return version
-	lst=[kw['path']]
+	lst=[]+path
 	defi=kw.get('define_variable',None)
 	if not defi:
@@ -163,5 +179,5 @@
 	for key,val in defi.items():
 		lst.append('--define-variable=%s=%s'%(key,val))
-	static=False
+	static=kw.get('force_static',False)
 	if'args'in kw:
 		args=Utils.to_list(kw['args'])
@@ -185,5 +201,5 @@
 		kw['okmsg']='yes'
 	define_it()
-	self.parse_flags(ret,kw.get('uselib_store',kw['package'].upper()),kw.get('env',self.env),force_static=static)
+	self.parse_flags(ret,kw.get('uselib_store',kw['package'].upper()),kw.get('env',self.env),force_static=static,posix=kw.get('posix',None))
 	return ret
 @conf
@@ -195,5 +211,5 @@
 	self.validate_cfg(kw)
 	if'msg'in kw:
-		self.start_msg(kw['msg'])
+		self.start_msg(kw['msg'],**kw)
 	ret=None
 	try:
@@ -201,5 +217,5 @@
 	except self.errors.WafError:
 		if'errmsg'in kw:
-			self.end_msg(kw['errmsg'],'YELLOW')
+			self.end_msg(kw['errmsg'],'YELLOW',**kw)
 		if Logs.verbose>1:
 			raise
@@ -207,10 +223,23 @@
 			self.fatal('The configuration failed')
 	else:
+		if not ret:
+			ret=True
 		kw['success']=ret
 		if'okmsg'in kw:
-			self.end_msg(self.ret_msg(kw['okmsg'],kw))
+			self.end_msg(self.ret_msg(kw['okmsg'],kw),**kw)
 	return ret
+def build_fun(bld):
+	if bld.kw['compile_filename']:
+		node=bld.srcnode.make_node(bld.kw['compile_filename'])
+		node.write(bld.kw['code'])
+	o=bld(features=bld.kw['features'],source=bld.kw['compile_filename'],target='testprog')
+	for k,v in bld.kw.items():
+		setattr(o,k,v)
+	if not bld.kw.get('quiet',None):
+		bld.conf.to_log("==>\n%s\n<=="%bld.kw['code'])
 @conf
 def validate_c(self,kw):
+	if not'build_fun'in kw:
+		kw['build_fun']=build_fun
 	if not'env'in kw:
 		kw['env']=self.env.derive()
@@ -307,5 +336,5 @@
 		if not'errmsg'in kw:
 			kw['errmsg']='no'
-	for(flagsname,flagstype)in[('cxxflags','compiler'),('cflags','compiler'),('linkflags','linker')]:
+	for(flagsname,flagstype)in(('cxxflags','compiler'),('cflags','compiler'),('linkflags','linker')):
 		if flagsname in kw:
 			if not'msg'in kw:
@@ -369,10 +398,10 @@
 def check(self,*k,**kw):
 	self.validate_c(kw)
-	self.start_msg(kw['msg'])
+	self.start_msg(kw['msg'],**kw)
 	ret=None
 	try:
-		ret=self.run_c_code(*k,**kw)
+		ret=self.run_build(*k,**kw)
 	except self.errors.ConfigurationError:
-		self.end_msg(kw['errmsg'],'YELLOW')
+		self.end_msg(kw['errmsg'],'YELLOW',**kw)
 		if Logs.verbose>1:
 			raise
@@ -383,8 +412,8 @@
 	ret=self.post_check(*k,**kw)
 	if not ret:
-		self.end_msg(kw['errmsg'],'YELLOW')
+		self.end_msg(kw['errmsg'],'YELLOW',**kw)
 		self.fatal('The configuration failed %r'%ret)
 	else:
-		self.end_msg(self.ret_msg(kw['okmsg'],kw))
+		self.end_msg(self.ret_msg(kw['okmsg'],kw),**kw)
 	return ret
 class test_exec(Task.Task):
@@ -409,62 +438,4 @@
 def test_exec_fun(self):
 	self.create_task('test_exec',self.link_task.outputs[0])
-CACHE_RESULTS=1
-COMPILE_ERRORS=2
-@conf
-def run_c_code(self,*k,**kw):
-	lst=[str(v)for(p,v)in kw.items()if p!='env']
-	h=Utils.h_list(lst)
-	dir=self.bldnode.abspath()+os.sep+(not Utils.is_win32 and'.'or'')+'conf_check_'+Utils.to_hex(h)
-	try:
-		os.makedirs(dir)
-	except OSError:
-		pass
-	try:
-		os.stat(dir)
-	except OSError:
-		self.fatal('cannot use the configuration test folder %r'%dir)
-	cachemode=getattr(Options.options,'confcache',None)
-	if cachemode==CACHE_RESULTS:
-		try:
-			proj=ConfigSet.ConfigSet(os.path.join(dir,'cache_run_c_code'))
-		except OSError:
-			pass
-		else:
-			ret=proj['cache_run_c_code']
-			if isinstance(ret,str)and ret.startswith('Test does not build'):
-				self.fatal(ret)
-			return ret
-	bdir=os.path.join(dir,'testbuild')
-	if not os.path.exists(bdir):
-		os.makedirs(bdir)
-	self.test_bld=bld=Build.BuildContext(top_dir=dir,out_dir=bdir)
-	bld.init_dirs()
-	bld.progress_bar=0
-	bld.targets='*'
-	if kw['compile_filename']:
-		node=bld.srcnode.make_node(kw['compile_filename'])
-		node.write(kw['code'])
-	bld.logger=self.logger
-	bld.all_envs.update(self.all_envs)
-	bld.env=kw['env']
-	o=bld(features=kw['features'],source=kw['compile_filename'],target='testprog')
-	for k,v in kw.items():
-		setattr(o,k,v)
-	self.to_log("==>\n%s\n<=="%kw['code'])
-	bld.targets='*'
-	ret=-1
-	try:
-		try:
-			bld.compile()
-		except Errors.WafError:
-			ret='Test does not build: %s'%Utils.ex_stack()
-			self.fatal(ret)
-		else:
-			ret=getattr(bld,'retval',0)
-	finally:
-		proj=ConfigSet.ConfigSet()
-		proj['cache_run_c_code']=ret
-		proj.store(os.path.join(dir,'cache_run_c_code'))
-	return ret
 @conf
 def check_cxx(self,*k,**kw):
@@ -530,7 +501,5 @@
 	return(self.env.HAVE_PAT or'HAVE_%s')%Utils.quote_define_name(key)
 @conf
-def write_config_header(self,configfile='',guard='',top=False,env=None,defines=True,headers=False,remove=True,define_prefix=''):
-	if env:
-		Logs.warn('Cannot pass env to write_config_header')
+def write_config_header(self,configfile='',guard='',top=False,defines=True,headers=False,remove=True,define_prefix=''):
 	if not configfile:configfile=WAF_CONFIG_H
 	waf_guard=guard or'W_%s_WAF'%Utils.quote_define_name(configfile)
@@ -555,10 +524,14 @@
 			lst.append('#include <%s>'%x)
 	if defines:
-		for x in self.env[DEFKEYS]:
-			if self.is_defined(x):
-				val=self.get_define(x)
-				lst.append('#define %s %s'%(define_prefix+x,val))
-			else:
-				lst.append('/* #undef %s */'%(define_prefix+x))
+		tbl={}
+		for k in self.env['DEFINES']:
+			a,_,b=k.partition('=')
+			tbl[a]=b
+		for k in self.env[DEFKEYS]:
+			try:
+				txt='#define %s%s %s'%(define_prefix,k,tbl[k])
+			except KeyError:
+				txt='/* #undef %s%s */'%(define_prefix,k)
+			lst.append(txt)
 	return"\n".join(lst)
 @conf
@@ -585,5 +558,5 @@
 	conf.load('cxx')
 @conf
-def get_cc_version(conf,cc,gcc=False,icc=False):
+def get_cc_version(conf,cc,gcc=False,icc=False,clang=False):
 	cmd=cc+['-dM','-E','-']
 	env=conf.env.env or None
@@ -603,6 +576,10 @@
 	if icc and out.find('__INTEL_COMPILER')<0:
 		conf.fatal('Not icc/icpc')
+	if clang and out.find('__clang__')<0:
+		conf.fatal('Not clang/clang++')
+	if not clang and out.find('__clang__')>=0:
+		conf.fatal('Could not find g++, if renamed try eg: CXX=g++48 waf configure')
 	k={}
-	if icc or gcc:
+	if icc or gcc or clang:
 		out=out.splitlines()
 		for line in out:
@@ -646,7 +623,13 @@
 		else:
 			if isD('__clang__'):
-				conf.env['CC_VERSION']=(k['__clang_major__'],k['__clang_minor__'],k['__clang_patchlevel__'])
+				try:
+					conf.env['CC_VERSION']=(k['__clang_major__'],k['__clang_minor__'],k['__clang_patchlevel__'])
+				except KeyError:
+					conf.env['CC_VERSION']=(k['__GNUC__'],k['__GNUC_MINOR__'],k['__GNUC_PATCHLEVEL__'])
 			else:
-				conf.env['CC_VERSION']=(k['__GNUC__'],k['__GNUC_MINOR__'],k['__GNUC_PATCHLEVEL__'])
+				try:
+					conf.env['CC_VERSION']=(k['__GNUC__'],k['__GNUC_MINOR__'],k['__GNUC_PATCHLEVEL__'])
+				except KeyError:
+					conf.env['CC_VERSION']=(k['__GNUC__'],k['__GNUC_MINOR__'],0)
 	return k
 @conf
@@ -688,5 +671,5 @@
 def add_as_needed(self):
 	if self.env.DEST_BINFMT=='elf'and'gcc'in(self.env.CXX_NAME,self.env.CC_NAME):
-		self.env.append_unique('LINKFLAGS','--as-needed')
+		self.env.append_unique('LINKFLAGS','-Wl,--as-needed')
 class cfgtask(Task.TaskBase):
 	def display(self):
@@ -709,10 +692,8 @@
 @conf
 def multicheck(self,*k,**kw):
-	self.start_msg(kw.get('msg','Executing %d configuration tests'%len(k)))
+	self.start_msg(kw.get('msg','Executing %d configuration tests'%len(k)),**kw)
 	class par(object):
 		def __init__(self):
 			self.keep=False
-			self.cache_global=Options.cache_global
-			self.nocache=Options.options.nocache
 			self.returned_tasks=[]
 			self.task_sigs={}
@@ -742,5 +723,5 @@
 	for x in tasks:
 		if x.hasrun!=Task.SUCCESS:
-			self.end_msg(kw.get('errmsg','no'),color='YELLOW')
+			self.end_msg(kw.get('errmsg','no'),color='YELLOW',**kw)
 			self.fatal(kw.get('fatalmsg',None)or'One of the tests has failed, see the config.log for more information')
-	self.end_msg('ok')
+	self.end_msg('ok',**kw)
Index: waflib/Tools/c_preproc.py
===================================================================
--- waflib/Tools/c_preproc.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/c_preproc.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -16,5 +16,5 @@
 use_trigraphs=0
 strict_quotes=0
-g_optrans={'not':'!','and':'&&','bitand':'&','and_eq':'&=','or':'||','bitor':'|','or_eq':'|=','xor':'^','xor_eq':'^=','compl':'~',}
+g_optrans={'not':'!','not_eq':'!','and':'&&','and_eq':'&=','or':'||','or_eq':'|=','xor':'^','xor_eq':'^=','bitand':'&','bitor':'|','compl':'~',}
 re_lines=re.compile('^[ \t]*(#|%:)[ \t]*(ifdef|ifndef|if|else|elif|endif|include|import|define|undef|pragma)[ \t]*(.*)\r*$',re.IGNORECASE|re.MULTILINE)
 re_mac=re.compile("^[a-zA-Z_]\w*")
@@ -72,15 +72,15 @@
 	elif d=='/':c=a/b
 	elif d=='^':c=a^b
-	elif d=='|':c=a|b
-	elif d=='||':c=int(a or b)
-	elif d=='&':c=a&b
-	elif d=='&&':c=int(a and b)
 	elif d=='==':c=int(a==b)
-	elif d=='!=':c=int(a!=b)
+	elif d=='|'or d=='bitor':c=a|b
+	elif d=='||'or d=='or':c=int(a or b)
+	elif d=='&'or d=='bitand':c=a&b
+	elif d=='&&'or d=='and':c=int(a and b)
+	elif d=='!='or d=='not_eq':c=int(a!=b)
+	elif d=='^'or d=='xor':c=int(a^b)
 	elif d=='<=':c=int(a<=b)
 	elif d=='<':c=int(a<b)
 	elif d=='>':c=int(a>b)
 	elif d=='>=':c=int(a>=b)
-	elif d=='^':c=int(a^b)
 	elif d=='<<':c=a<<b
 	elif d=='>>':c=a>>b
@@ -382,5 +382,6 @@
 	else:
 		if toks[0][1]=='<'and toks[-1][1]=='>':
-			return stringize(toks).lstrip('<').rstrip('>')
+			ret='<',stringize(toks).lstrip('<').rstrip('>')
+			return ret
 	raise PreprocError("could not parse include %s."%txt)
 def parse_char(txt):
@@ -411,5 +412,7 @@
 			if v:
 				if name==IDENT:
-					try:v=g_optrans[v];name=OP
+					try:
+						g_optrans[v];
+						name=OP
 					except KeyError:
 						if v.lower()=="true":
@@ -473,4 +476,7 @@
 			return ret
 	def tryfind(self,filename):
+		if filename.endswith('.moc'):
+			self.names.append(filename)
+			return None
 		self.curfile=filename
 		found=self.cached_find_resource(self.currentnode_stack[-1],filename)
@@ -481,6 +487,5 @@
 		if found and not found in self.ban_includes:
 			self.nodes.append(found)
-			if filename[-4:]!='.moc':
-				self.addlines(found)
+			self.addlines(found)
 		else:
 			if not filename in self.names:
@@ -520,6 +525,5 @@
 			self.parse_cache=bld.parse_cache
 		except AttributeError:
-			bld.parse_cache={}
-			self.parse_cache=bld.parse_cache
+			self.parse_cache=bld.parse_cache={}
 		self.current_file=node
 		self.addlines(node)
Index: waflib/Tools/ccroot.py
===================================================================
--- waflib/Tools/ccroot.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/ccroot.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -76,5 +76,7 @@
 					name=name+'-'+nums[0]
 				elif self.env.DEST_OS=='openbsd':
-					pattern='%s.%s.%s'%(pattern,nums[0],nums[1])
+					pattern='%s.%s'%(pattern,nums[0])
+					if len(nums)>=2:
+						pattern+='.%s'%nums[1]
 			tmp=folder+os.sep+pattern%name
 			target=self.generator.path.find_or_declare(tmp)
@@ -82,4 +84,5 @@
 class stlink_task(link_task):
 	run_str='${AR} ${ARFLAGS} ${AR_TGT_F}${TGT} ${AR_SRC_F}${SRC}'
+	chmod=Utils.O644
 def rm_tgt(cls):
 	old=cls.run
@@ -112,5 +115,5 @@
 		inst_to=self.link_task.__class__.inst_to
 	if inst_to:
-		self.install_task=self.bld.install_files(inst_to,self.link_task.outputs[:],env=self.env,chmod=self.link_task.chmod)
+		self.install_task=self.bld.install_files(inst_to,self.link_task.outputs[:],env=self.env,chmod=self.link_task.chmod,task=self.link_task)
 @taskgen_method
 def use_rec(self,name,**kw):
@@ -140,4 +143,6 @@
 	p=self.tmp_use_prec
 	for x in self.to_list(getattr(y,'use',[])):
+		if self.env["STLIB_"+x]:
+			continue
 		try:
 			p[x].append(name)
@@ -191,9 +196,9 @@
 		var=y.tmp_use_var
 		if var and link_task:
-			if var=='LIB'or y.tmp_use_stlib:
+			if var=='LIB'or y.tmp_use_stlib or x in names:
 				self.env.append_value(var,[y.target[y.target.rfind(os.sep)+1:]])
 				self.link_task.dep_nodes.extend(y.link_task.outputs)
 				tmp_path=y.link_task.outputs[0].parent.path_from(self.bld.bldnode)
-				self.env.append_value(var+'PATH',[tmp_path])
+				self.env.append_unique(var+'PATH',[tmp_path])
 		else:
 			if y.tmp_use_objects:
@@ -206,9 +211,9 @@
 		try:
 			y=self.bld.get_tgen_by_name(x)
-		except Exception:
+		except Errors.WafError:
 			if not self.env['STLIB_'+x]and not x in self.uselib:
 				self.uselib.append(x)
 		else:
-			for k in self.to_list(getattr(y,'uselib',[])):
+			for k in self.to_list(getattr(y,'use',[])):
 				if not self.env['STLIB_'+k]and not k in self.uselib:
 					self.uselib.append(k)
@@ -239,14 +244,15 @@
 	_vars=self.get_uselib_vars()
 	env=self.env
-	for x in _vars:
-		y=x.lower()
-		env.append_unique(x,self.to_list(getattr(self,y,[])))
-	for x in self.features:
-		for var in _vars:
-			compvar='%s_%s'%(var,x)
-			env.append_value(var,env[compvar])
-	for x in self.to_list(getattr(self,'uselib',[])):
-		for v in _vars:
-			env.append_value(v,env[v+'_'+x])
+	app=env.append_value
+	feature_uselib=self.features+self.to_list(getattr(self,'uselib',[]))
+	for var in _vars:
+		y=var.lower()
+		val=getattr(self,y,[])
+		if val:
+			app(var,self.to_list(val))
+		for x in feature_uselib:
+			val=env['%s_%s'%(var,x)]
+			if val:
+				app(var,val)
 @feature('cshlib','cxxshlib','fcshlib')
 @after_method('apply_link')
@@ -272,12 +278,17 @@
 		else:
 			self.link_task.inputs.append(node)
-	try:
-		inst_to=self.install_path
-	except AttributeError:
-		inst_to=self.link_task.__class__.inst_to
-	if not inst_to:
-		return
-	self.implib_install_task=self.bld.install_as('${LIBDIR}/%s'%implib.name,implib,self.env)
-re_vnum=re.compile('^([1-9]\\d*|0)[.]([1-9]\\d*|0)[.]([1-9]\\d*|0)$')
+	if getattr(self,'install_task',None):
+		try:
+			inst_to=self.install_path_implib
+		except AttributeError:
+			try:
+				inst_to=self.install_path
+			except AttributeError:
+				inst_to='${IMPLIBDIR}'
+				self.install_task.dest='${BINDIR}'
+				if not self.env.IMPLIBDIR:
+					self.env.IMPLIBDIR=self.env.LIBDIR
+		self.implib_install_task=self.bld.install_files(inst_to,implib,env=self.env,chmod=self.link_task.chmod,task=self.link_task)
+re_vnum=re.compile('^([1-9]\\d*|0)([.]([1-9]\\d*|0)[.]([1-9]\\d*|0))?$')
 @feature('cshlib','cxxshlib','dshlib','fcshlib','vnum')
 @after_method('apply_link','propagate_uselib_vars')
@@ -301,5 +312,8 @@
 		self.env.append_value('LINKFLAGS',v.split())
 	if self.env.DEST_OS!='openbsd':
-		self.create_task('vnum',node,[node.parent.find_or_declare(name2),node.parent.find_or_declare(name3)])
+		outs=[node.parent.find_or_declare(name3)]
+		if name2!=name3:
+			outs.append(node.parent.find_or_declare(name2))
+		self.create_task('vnum',node,outs)
 	if getattr(self,'install_task',None):
 		self.install_task.hasrun=Task.SKIP_ME
@@ -312,7 +326,10 @@
 		else:
 			t1=bld.install_as(path+os.sep+name3,node,env=self.env,chmod=self.link_task.chmod)
-			t2=bld.symlink_as(path+os.sep+name2,name3)
 			t3=bld.symlink_as(path+os.sep+libname,name3)
-			self.vnum_install_task=(t1,t2,t3)
+			if name2!=name3:
+				t2=bld.symlink_as(path+os.sep+name2,name3)
+				self.vnum_install_task=(t1,t2,t3)
+			else:
+				self.vnum_install_task=(t1,t3)
 	if'-dynamiclib'in self.env['LINKFLAGS']:
 		try:
@@ -328,4 +345,6 @@
 	quient=True
 	ext_in=['.bin']
+	def keyword(self):
+		return'Symlinking'
 	def run(self):
 		for x in self.outputs:
Index: waflib/Tools/cxx.py
===================================================================
--- waflib/Tools/cxx.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/cxx.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -12,5 +12,5 @@
 	TaskGen.task_gen.mappings['.c']=TaskGen.task_gen.mappings['.cpp']
 class cxx(Task.Task):
-	run_str='${CXX} ${ARCH_ST:ARCH} ${CXXFLAGS} ${CPPFLAGS} ${FRAMEWORKPATH_ST:FRAMEWORKPATH} ${CPPPATH_ST:INCPATHS} ${DEFINES_ST:DEFINES} ${CXX_SRC_F}${SRC} ${CXX_TGT_F}${TGT}'
+	run_str='${CXX} ${ARCH_ST:ARCH} ${CXXFLAGS} ${CPPFLAGS} ${FRAMEWORKPATH_ST:FRAMEWORKPATH} ${CPPPATH_ST:INCPATHS} ${DEFINES_ST:DEFINES} ${CXX_SRC_F}${SRC} ${CXX_TGT_F}${TGT[0].abspath()}'
 	vars=['CXXDEPS']
 	ext_in=['.h']
Index: waflib/Tools/dmd.py
===================================================================
--- waflib/Tools/dmd.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/dmd.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -9,7 +9,7 @@
 def find_dmd(conf):
 	conf.find_program(['dmd','dmd2','ldc'],var='D')
-	out=conf.cmd_and_log([conf.env.D,'--help'])
+	out=conf.cmd_and_log(conf.env.D+['--help'])
 	if out.find("D Compiler v")==-1:
-		out=conf.cmd_and_log([conf.env.D,'-version'])
+		out=conf.cmd_and_log(conf.env.D+['-version'])
 		if out.find("based on DMD v1.")==-1:
 			conf.fatal("detected compiler is not dmd/ldc")
@@ -41,5 +41,5 @@
 	conf.find_dmd()
 	if sys.platform=='win32':
-		out=conf.cmd_and_log([conf.env.D,'--help'])
+		out=conf.cmd_and_log(conf.env.D+['--help'])
 		if out.find("D Compiler v2.")>-1:
 			conf.fatal('dmd2 on Windows is not supported, use gdc or ldc2 instead')
Index: waflib/Tools/fc.py
===================================================================
--- waflib/Tools/fc.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/fc.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -90,6 +90,4 @@
 	inst_to='${LIBDIR}'
 class fcprogram_test(fcprogram):
-	def can_retrieve_cache(self):
-		return False
 	def runnable_status(self):
 		ret=super(fcprogram_test,self).runnable_status()
Index: waflib/Tools/flex.py
===================================================================
--- waflib/Tools/flex.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/flex.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -29,4 +29,4 @@
 	conf.find_program('flex',var='FLEX')
 	conf.env.FLEXFLAGS=['-t']
-	if re.search(r"\\msys\\[0-9.]+\\bin\\flex.exe$",conf.env.FLEX):
+	if re.search(r"\\msys\\[0-9.]+\\bin\\flex.exe$",conf.env.FLEX[0]):
 		conf.env.FLEX_MSYS=True
Index: waflib/Tools/g95.py
===================================================================
--- waflib/Tools/g95.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/g95.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -10,5 +10,4 @@
 def find_g95(conf):
 	fc=conf.find_program('g95',var='FC')
-	fc=conf.cmd_to_list(fc)
 	conf.get_g95_version(fc)
 	conf.env.FC_NAME='G95'
Index: waflib/Tools/gdc.py
===================================================================
--- waflib/Tools/gdc.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/gdc.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -9,6 +9,6 @@
 def find_gdc(conf):
 	conf.find_program('gdc',var='D')
-	out=conf.cmd_and_log([conf.env.D,'--version'])
-	if out.find("gdc ")==-1:
+	out=conf.cmd_and_log(conf.env.D+['--version'])
+	if out.find("gdc")==-1:
 		conf.fatal("detected compiler is not gdc")
 @conf
Index: waflib/Tools/gfortran.py
===================================================================
--- waflib/Tools/gfortran.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/gfortran.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -10,5 +10,4 @@
 def find_gfortran(conf):
 	fc=conf.find_program(['gfortran','g77'],var='FC')
-	fc=conf.cmd_to_list(fc)
 	conf.get_gfortran_version(fc)
 	conf.env.FC_NAME='GFORTRAN'
Index: waflib/Tools/glib2.py
===================================================================
--- waflib/Tools/glib2.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/glib2.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -4,6 +4,7 @@
 
 import os
-from waflib import Task,Utils,Options,Errors,Logs
-from waflib.TaskGen import taskgen_method,before_method,after_method,feature
+from waflib import Context,Task,Utils,Options,Errors,Logs
+from waflib.TaskGen import taskgen_method,before_method,after_method,feature,extension
+from waflib.Configure import conf
 @taskgen_method
 def add_marshal_file(self,filename,prefix):
@@ -99,12 +100,4 @@
 		filename_list=[filename_list]
 	self.settings_enum_files=filename_list
-def r_change_ext(self,ext):
-	name=self.name
-	k=name.rfind('.')
-	if k>=0:
-		name=name[:k]+ext
-	else:
-		name=name+ext
-	return self.parent.find_or_declare([name])
 @feature('glib2')
 def process_settings(self):
@@ -137,5 +130,5 @@
 		schema_task.set_inputs(source_list)
 		schema_task.env['GLIB_COMPILE_SCHEMAS_OPTIONS']=[("--schema-file="+k.abspath())for k in source_list]
-		target_node=r_change_ext(schema_node,'.xml.valid')
+		target_node=schema_node.change_ext('.xml.valid')
 		schema_task.set_outputs(target_node)
 		schema_task.env['GLIB_VALIDATE_SCHEMA_OUTPUT']=target_node.abspath()
@@ -156,8 +149,67 @@
 	run_str='rm -f ${GLIB_VALIDATE_SCHEMA_OUTPUT} && ${GLIB_COMPILE_SCHEMAS} --dry-run ${GLIB_COMPILE_SCHEMAS_OPTIONS} && touch ${GLIB_VALIDATE_SCHEMA_OUTPUT}'
 	color='PINK'
-def configure(conf):
+@extension('.gresource.xml')
+def process_gresource_source(self,node):
+	if not self.env['GLIB_COMPILE_RESOURCES']:
+		raise Errors.WafError("Unable to process GResource file - glib-compile-resources was not found during configure")
+	if'gresource'in self.features:
+		return
+	h_node=node.change_ext('_xml.h')
+	c_node=node.change_ext('_xml.c')
+	self.create_task('glib_gresource_source',node,[h_node,c_node])
+	self.source.append(c_node)
+@feature('gresource')
+def process_gresource_bundle(self):
+	for i in self.to_list(self.source):
+		node=self.path.find_resource(i)
+		task=self.create_task('glib_gresource_bundle',node,node.change_ext(''))
+		inst_to=getattr(self,'install_path',None)
+		if inst_to:
+			self.bld.install_files(inst_to,task.outputs)
+class glib_gresource_base(Task.Task):
+	color='BLUE'
+	base_cmd='${GLIB_COMPILE_RESOURCES} --sourcedir=${SRC[0].parent.srcpath()} --sourcedir=${SRC[0].bld_dir()}'
+	def scan(self):
+		bld=self.generator.bld
+		kw={}
+		try:
+			if not kw.get('cwd',None):
+				kw['cwd']=bld.cwd
+		except AttributeError:
+			bld.cwd=kw['cwd']=bld.variant_dir
+		kw['quiet']=Context.BOTH
+		cmd=Utils.subst_vars('${GLIB_COMPILE_RESOURCES} --sourcedir=%s --sourcedir=%s --generate-dependencies %s'%(self.inputs[0].parent.srcpath(),self.inputs[0].bld_dir(),self.inputs[0].bldpath()),self.env)
+		output=bld.cmd_and_log(cmd,**kw)
+		nodes=[]
+		names=[]
+		for dep in output.splitlines():
+			if dep:
+				node=bld.bldnode.find_node(dep)
+				if node:
+					nodes.append(node)
+				else:
+					names.append(dep)
+		return(nodes,names)
+class glib_gresource_source(glib_gresource_base):
+	vars=['GLIB_COMPILE_RESOURCES']
+	fun_h=Task.compile_fun_shell(glib_gresource_base.base_cmd+' --target=${TGT[0].abspath()} --generate-header ${SRC}')
+	fun_c=Task.compile_fun_shell(glib_gresource_base.base_cmd+' --target=${TGT[1].abspath()} --generate-source ${SRC}')
+	ext_out=['.h']
+	def run(self):
+		return self.fun_h[0](self)or self.fun_c[0](self)
+class glib_gresource_bundle(glib_gresource_base):
+	run_str=glib_gresource_base.base_cmd+' --target=${TGT} ${SRC}'
+	shell=True
+@conf
+def find_glib_genmarshal(conf):
 	conf.find_program('glib-genmarshal',var='GLIB_GENMARSHAL')
-	conf.find_perl_program('glib-mkenums',var='GLIB_MKENUMS')
-	conf.find_program('glib-compile-schemas',var='GLIB_COMPILE_SCHEMAS',mandatory=False)
+@conf
+def find_glib_mkenums(conf):
+	if not conf.env.PERL:
+		conf.find_program('perl',var='PERL')
+	conf.find_program('glib-mkenums',interpreter='PERL',var='GLIB_MKENUMS')
+@conf
+def find_glib_compile_schemas(conf):
+	conf.find_program('glib-compile-schemas',var='GLIB_COMPILE_SCHEMAS')
 	def getstr(varname):
 		return getattr(Options.options,varname,getattr(conf.env,varname,''))
@@ -170,4 +222,13 @@
 		gsettingsschemadir=os.path.join(datadir,'glib-2.0','schemas')
 	conf.env['GSETTINGSSCHEMADIR']=gsettingsschemadir
+@conf
+def find_glib_compile_resources(conf):
+	conf.find_program('glib-compile-resources',var='GLIB_COMPILE_RESOURCES')
+def configure(conf):
+	conf.find_glib_genmarshal()
+	conf.find_glib_mkenums()
+	conf.find_glib_compile_schemas(mandatory=False)
+	conf.find_glib_compile_resources(mandatory=False)
 def options(opt):
-	opt.add_option('--gsettingsschemadir',help='GSettings schema location [Default: ${datadir}/glib-2.0/schemas]',default='',dest='GSETTINGSSCHEMADIR')
+	gr=opt.add_option_group('Installation directories')
+	gr.add_option('--gsettingsschemadir',help='GSettings schema location [DATADIR/glib-2.0/schemas]',default='',dest='GSETTINGSSCHEMADIR')
Index: waflib/Tools/icc.py
===================================================================
--- waflib/Tools/icc.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/icc.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -10,15 +10,7 @@
 	if sys.platform=='cygwin':
 		conf.fatal('The Intel compiler does not work on Cygwin')
-	v=conf.env
-	cc=None
-	if v['CC']:cc=v['CC']
-	elif'CC'in conf.environ:cc=conf.environ['CC']
-	if not cc:cc=conf.find_program('icc',var='CC')
-	if not cc:cc=conf.find_program('ICL',var='CC')
-	if not cc:conf.fatal('Intel C Compiler (icc) was not found')
-	cc=conf.cmd_to_list(cc)
+	cc=conf.find_program(['icc','ICL'],var='CC')
 	conf.get_cc_version(cc,icc=True)
-	v['CC']=cc
-	v['CC_NAME']='icc'
+	conf.env.CC_NAME='icc'
 def configure(conf):
 	conf.find_icc()
